'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                DemoCap                                   |
'|                                                                          |
'|          Monitor and capture any sound played on the computer            |
'|             and (optionaly) save it to a local WAVE file.                |
'|                                                                          |
'|                    This demo requires AudioCap.DLL                       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-18-2007 (MM-DD-YYYY)            |
'|                        Last revised : 12-18-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "DemoCap.exe"

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE
DECLARE FUNCTION SK_DRAWICON() AS LONG            '// SHALL WE DRAW THE DEFAULT ICON

#INCLUDE "ZSKIN.INC"

DECLARE FUNCTION AudioCaptureGain LIB "AUDIOCAP.DLL" ALIAS "AudioCaptureGain" (BYVAL UseGain AS SINGLE, BYVAL RW AS LONG) AS SINGLE
DECLARE FUNCTION AudioCaptureStart LIB "AUDIOCAP.DLL" ALIAS "AudioCaptureStart" ( _
    BYVAL hParent AS LONG, _
    zAudioFile AS ASCIIZ, _
    BYVAL UseWaveFormat AS LONG, _
    BYVAL hView AS LONG, _
    BYVAL nDelay AS LONG, _
    BYVAL FlagWrite AS LONG, _
    BYVAL BTN_Silent AS LONG, _
    BYVAL BTN_Actif AS LONG) AS LONG
DECLARE FUNCTION AudioCaptureStatus LIB "AUDIOCAP.DLL" ALIAS "AudioCaptureStatus" () AS LONG
DECLARE SUB AudioCaptureStop LIB "AUDIOCAP.DLL" ALIAS "AudioCaptureStop" ()

%WS_EX_CLIENTEDGE                               = &H00000200
%ES_AUTOHSCROLL                                 = &H80&

%XMIN_SIZE = 281
%YMIN_SIZE = 315

'----------------------------------------------------------------------
%ID_FRAMEBUTTON = 1
%ID_MONITORING  = 2
%ID_CAPTURE     = 3
%ID_DESTINATION = 4
%ID_EDIT        = 5
%ID_OSCILLO     = 6
%ID_START       = 7
%ID_STOP        = 8
%ID_MIXER       = 9
'----------------------------------------------------------------------
DECLARE FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                          BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS
    LOCAL hCtrl                AS LONG

    zClass = "ZDEMOCAP"

    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
    IF IsInitialized THEN

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = 50 ' MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = 50 ' MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              "", _                   ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN
          CALL zDRAWICON(1, 1) '//Enable draw icon

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(hMain, zsExePath() + "DemoCap.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls(hMain)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(5) ' 5 = UseStep for composited window on XP

'          hCtrl = zGetMainItem(%ID_VISUAL)
'          CALL SetTimer(hMain, %VISUAL_TIMER, 0, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
'             IF Msg.message = %WM_KEYDOWN AND Msg.wParam = %VK_F1 THEN
'                CALL zPutFocusOn(zGetMainItem(%ID_BTN_HELP))
'             ELSE
                IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                   CALL TranslateMessage(Msg)
                   CALL DispatchMessage(Msg)
                END IF
'             END IF
          WEND
'          CALL KillTimer(hMain, %VISUAL_TIMER)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL K, x, y, hList, hCtrl, imgW, imgH, gCtrl AS LONG
    LOCAL Alpha, Red, Green, Blue AS BYTE
    LOCAL nPercent, nLen AS LONG, sDataString AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

''   Create the GDImage graphic control
'    IF RegisterGDImageClass() THEN
'       zClass = "ZIMAGECTRL"
'       Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
'       StyleEx& = 0'%WS_EX_STATICEDGE
'       gDimage& = CreateWindowEx(StyleEx&, _
'                              zClass, _                  ' GDImage class name
'                              "", _                      ' Optional full path name to picture
'                              Style&, _                  ' window style
'                              17, _                      ' initial x position
'                              42, _                      ' initial y position
'                              588, _                     ' Calculate Window Width
'                              440, _                     ' Calculate Window Height
'                              hMain, _                   ' parent window handle
'                              %ID_GDIMAGE, _             ' ControlID
'                              zsInstance(), _            ' program instance handle
'                              BYVAL 0)                   ' creation parameters
'
''      Resize the control to macth the whole size of the parent window
'       CALL zSetAnchorMode(gDimage&, %ANCHOR_HEIGHT_WIDTH)
'
'       hBitmap& = ZI_CreateBitmapFromFile("C:\travail\sdk\template\crystal\resource\blue1.png", bmW&, bmH&)
'       CALL ZD_DrawBitmapToCtrl(gDimage&, 150, 150, _
'                                hBitmap&, &HFFFFFFFF, 1, %ZS_VISIBLE)
'       CALL ZD_UsePngOpacity(1, %TRUE)
'       CALL zSetZorder(gDimage&, %HWND_TOP)
'   END IF

'   ___________________

    hCtrl = zFrameButton(hMain, (SK_FOLDER() + "Frame3D.png"), "", 11, 33, 258, 85, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'   ___________________

    hCtrl = zRadioButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Monitoring only", 18, 42, 110, 22, %ID_MONITORING, SK_BTNTEXTCOLOR(), 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)

    hCtrl = zRadioButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "Capture to Wave", 18, 64, 110, 22, %ID_CAPTURE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Change destination", 130, 64, 135, 22, %ID_DESTINATION, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = CreateWindowEx(%WS_EX_CLIENTEDGE, "Edit", zsExePath() + "capture.wav", _
                           %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %ES_AUTOHSCROLL, _
                           14, 92, 252, 16, hMain, %ID_EDIT, zsInstance(), BYVAL %NULL)
    CALL zSetCTLFont(hCtrl, zDefaultFont)           



    hCtrl = zStaticCenter ($cr+$cr+$cr+$cr+"Play audio file, movie or internet radio,"+$cr+"then press the [Start capture] button.", _
                          13, 122, 254, 130, hMain, %ID_OSCILLO)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER)
    CALL zSetZorder(hCtrl, %HWND_TOP)


    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Start capture", 11, 258, 127, 22, %ID_START, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Stop capture", 142, 258, 127, 22, %ID_STOP, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)

    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_Push.png"), "Mixer setup", 11, 285, 258, 22, %ID_MIXER, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)

'    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Help.png"), 7, 4, %ID_BTN_HELP, 0)
'    CALL zGetImageSize(zGetButImageProperty(hCtrl), imgW, imgH): imgW = imgW \ 5
'    CALL zSetZorder(hCtrl, %HWND_TOP)
'    CALL zCreateToolTip(hCtrl, "About")

'   // Set LED's anchor mode to default top right
    CALL zSetAnchorMode(GetDlgItem(hMain, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(hMain, %ID_LED), %HWND_TOP)

'   // Use the Skin's name for caption
    CALL zSetCTLText(hMain, (PARSE$(SK_AUTHOR(), $zLim, 1)))

'    hCtrl = zPushButton(hMain, (SK_FOLDER() + "BTN_About.png"), "", 657, 494, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
'    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
'    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)
    IF ChangeBackground THEN CALL zUpdateWindow(hWnd, 0)

         'CALL zDrawBackground()
         'CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
         'CALL zUpdateWindow(hWnd, 0)
END SUB

TYPE BROWSEINFO
    hWndOwner      AS DWORD
    pIDLRoot       AS DWORD
    pszDisplayName AS ASCIIZ PTR
    lpszTitle      AS ASCIIZ PTR
    ulFlags        AS DWORD
    lpfnCallback   AS DWORD
    lParam         AS LONG
    iImage         AS LONG
END TYPE

%BIF_RETURNONLYFSDIRS   = &H0001  ' For finding a folder to start document searching
%BIF_DONTGOBELOWDOMAIN  = &H0002  ' For starting the Find Computer
%BIF_RETURNFSANCESTORS  = &H0008
%BIF_EDITBOX            = &H0010
%BIF_NEWDIALOGSTYLE     = &H0040
%BIF_USENEWUI           = %BIF_NEWDIALOGSTYLE OR %BIF_EDITBOX
%BFFM_INITIALIZED       = 1
%BFFM_ENABLEOK          = %WM_USER + 101
%BFFM_SETSELECTION      = %WM_USER + 102
%BFFM_SELCHANGED        = 2
%SUBDIR                 = &B010000
%SYSTEM                 = &B000100
DECLARE FUNCTION SHGetPathFromIDList LIB "SHELL32.DLL" ALIAS "SHGetPathFromIDListA" (pidList AS ANY, lpBuffer AS ASCIIZ) AS LONG
DECLARE SUB      CoTaskMemFree LIB "ole32.dll" ALIAS "CoTaskMemFree" (BYVAL pMem AS DWORD)
DECLARE FUNCTION SHBrowseForFolder LIB "SHELL32.DLL" ALIAS "SHBrowseForFolderA" (lpbi AS BROWSEINFO) AS DWORD

FUNCTION BrowseForFolderProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

   LOCAL szBuffer AS ASCIIZ * %MAX_PATH

   IF wMsg = %BFFM_INITIALIZED THEN
      SendMessage hWnd, %BFFM_SETSELECTION, %TRUE, lParam
   ELSEIF wMsg = %BFFM_SELCHANGED THEN
      SHGetPathFromIDList BYVAL wParam, szBuffer
      IF wParam = 0 OR _                            ' No id number
         LEN(szBuffer) = 0 OR _                     ' No name
         (GETATTR(szBuffer) AND %SUBDIR) = 0 OR _   ' Not a real subdir
         MID$(szBuffer, 2, 1) <> ":" THEN               ' Not a local or mapped drive
           CALL SendMessage(hWnd, %BFFM_ENABLEOK, 0, 0)
       ELSEIF (GETATTR(szBuffer) AND %SYSTEM) AND RIGHT$(szBuffer,2) <> ":\" THEN ' exclude system folders, allow root directories
         CALL SendMessage(hWnd, %BFFM_ENABLEOK, 0, 0)
       END IF
   END IF

END FUNCTION

FUNCTION BrowseForFolder (hWnd AS DWORD, strTitle AS STRING, StartFolder AS STRING) AS STRING

   LOCAL szBuffer   AS ASCIIZ * %MAX_PATH
   LOCAL bi         AS BROWSEINFO
   LOCAL lpIDList   AS LONG

   bi.hWndOwner    = hWnd
   bi.lpszTitle    = STRPTR(strTitle)
   bi.ulFlags      = %BIF_RETURNONLYFSDIRS OR %BIF_DONTGOBELOWDOMAIN OR %BIF_USENEWUI OR %BIF_RETURNFSANCESTORS
   bi.lpfnCallback = CODEPTR(BrowseForFolderProc)
   bi.lParam       = STRPTR(StartFolder)
   lpIDList        = SHBrowseForFolder(bi)

   IF lpIDList AND SHGetPathFromIDList(BYVAL lpIDList, szBuffer) THEN
      FUNCTION = szBuffer
      CALL CoTaskMemFree(lpIDList)
   END IF

END FUNCTION

FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

    LOCAL rc AS RECT, p AS POINTAPI, ps AS PAINTSTRUCT
    LOCAL szFullWaveName AS ASCIIZ * %MAX_PATH
    LOCAL sDefaultPath, sFileName, sNewPath AS STRING
    LOCAL hFound, Recording, nRW, nFlagWrite, nDelay, nMute, nOscillo, nPlaying AS LONG, rGain AS SINGLE

    STATIC IsMoving AS LONG
    
    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)
         CASE %ID_MONITORING
         CASE %ID_CAPTURE
         CASE %ID_DESTINATION
              CALL zSplitN(zGetCTLText(zGetMainItem(%ID_EDIT)), sDefaultPath, sFileName)
              sNewPath = BrowseForFolder(0, "Destination folder", sDefaultPath)
              IF LEN(sNewPath) THEN
                 sDefaultPath = RTRIM$(sNewPath, $Anti) + $Anti + sFileName
                 CALL zSetCTLText(zGetMainItem(%ID_EDIT),(sDefaultPath))
              END IF

         CASE %ID_EDIT
         CASE %ID_START
              IF AudioCaptureStatus() THEN AudioCaptureStop()
              '// Start audio capture.
              szFullWaveName = zGetCTLText(zGetMainItem(%ID_EDIT)) '// The WAVE file name to create
              nDelay = 2000                                        '// Monitoring milli second delay
              nOscillo = zGetMainItem(%ID_OSCILLO)                 '// Oscilloscope container
              IF zGetCheckButtonStatus(zGetMainItem(%ID_CAPTURE)) THEN
                 nFlagWrite = -1                                   '// To create the WAVE file
              ELSE
                 nFlagWrite = 0                                    '// Monitoring only
              END IF
              CALL AudioCaptureGain(1.5, %TRUE)                    '// Gain in the range 1.0 to 3.0
              CALL zsKillFile(szFullWaveName)                      '// Remove any previous existing WAVE file                
              Recording = AudioCaptureStart(hWnd, _                '// Handle of the parent window.
                                            szFullWaveName, _      '// Full path name to record the WAVE file.
                                            2048, _                '// %WAVE_FORMAT_4S16 audio format.
                                            nOscillo, _            '// Handle of the image field to display the grapic curve.
                                            nDelay, _              '// Activity detection delay.
                                            nFlagWrite, _          '// Tue = create the WAVE file, False = monitoring only.
                                            nMute, _               '// Handle to BTN_Mute callback button.
                                            nPlaying)              '// Handle to BTN_Playing callback button.

             'IF Recording = 0 THEN
             '   MsgBox "Unable to start audio capture."
             'END

         CASE %ID_STOP
              '// Stop audio capture
              CALL AudioCaptureStop()
              CALL zUpdateWindow(zGetMainItem(%ID_OSCILLO), 0)
         CASE %ID_MIXER
              hFound = FindWindow("Volume Control", "")
              IF hFound THEN
                 IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
                 CALL SetForeGroundWindow(hFound)
              ELSE
                 CALL ShellExecute(BYVAL %NULL, "open", "sndvol32.exe", "/r", "", %SW_SHOW)
              END IF
         END SELECT

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

     CASE %WM_DESTROY
        ' is sent when program ends - a good place to delete any created objects and
        ' store settings in file for next run, etc. Must send PostQuitMessage to end
        ' properly in SDK-style dialogs. The PostQuitMessage function sends a WM_QUIT
        ' message to the program's (thread's) message queue, and then WM_QUIT causes
        ' the GetMessage function to return zero in WINMAIN's message loop.
        '----------------------------------------------------------------------------
        CALL PostQuitMessage(0)
        FUNCTION = 0 : EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

'   //START AERO section ---------------------------------------------------------
    CASE %WM_TIMER
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               IF zIsLButtonDown() = 0 THEN IsMoving = 0
               IF IsMoving = 0 OR (zIsLButtonDown() AND IsMoving) THEN
                  CALL GetWindowRect(hWnd, rc)
                  CALL zMoveBackground(rc.nLeft, rc.nTop, 0)
                  CALL zUpdateWindow(hWnd, 0)
               END IF
            END IF
         END IF

    CASE %WM_NCLBUTTONDOWN
         IsMoving = -1

    CASE %WM_MOVING
         IF zDwmIsCompositionEnabled() = 0 THEN
            IF SK_AEROEMULATE() AND zIsAeroLayered() THEN
               DIM rw AS RECT PTR
               rw = lparam
               CALL zMoveBackground(@rw.nLeft,@rw.nTop, 0)
               CALL zUpdateWindow(hWnd, 0)
               FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
'   //END AERO section ---------------------------------------------------------

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION
